## bornagain 22~git20250325170646.93042f5+ds3

=== CMakeLists.txt ===
###########################################################################
# top-level CMakeLists.txt for building BornAgain
############################################################################

### CMake configuration

cmake_minimum_required(VERSION 3.20 FATAL_ERROR)
if (CMAKE_VERSION GREATER_EQUAL 3.30)
    cmake_policy(SET CMP0167 OLD)
    # Old policy uses FindBoost.cmake provided by CMake, which is deprecated.
    # New policy uses BoostConfig.cmake provided by Boost.  It returns targets
    # Boost::ProgramOptions etc instead of library paths.  We still have to find
    # out how replace the configure_file command in MakePythonWheel.cmake.
    # See https://jugit.fz-juelich.de/mlz/bornagain/-/issues/1074.
endif()
if (CMAKE_VERSION GREATER_EQUAL 3.31)
    cmake_policy(SET CMP0175 NEW)
endif()
if (CMAKE_VERSION GREATER_EQUAL 3.31)
    cmake_policy(SET CMP0177 OLD)
    # New behavior, introduced in CMake 3.31, normalizes all DESTINATION values
    # given in any form of the install() command.
    # Conversion to NEW behavior postponed until we require CMake >= 3.31.
endif()

set(CMAKE_MODULE_PATH
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/cmake/find)
set(CONFIGURABLES_DIR ${CMAKE_SOURCE_DIR}/cmake/configurables)

include(cmake/BornAgain/Git)
message(STATUS "Git branch '${GIT_BRANCH}' at commit ${GIT_COMMIT}, tag: '${GIT_TAG}'")

include(cmake/commons/PreventInSourceBuilds)

### Project settings

project(BornAgain
    VERSION 22.0 # will always remain binary; minor equals patch-level
    DESCRIPTION "BornAgain: simulate and fit reflectometry and grazing-incidence scattering."
    HOMEPAGE_URL https://www.bornagainproject.org
    LANGUAGES CXX)

### Options

# options that are on by default (switch off for accelerated builds of limited scope)
option(BA_CPP20 "Use C++20 standard" OFF)
option(BORNAGAIN_PYTHON "Build with Python support" ON)
option(BA_GUI "Build a graphical user interface" ON)
option(BA_TIFF_SUPPORT "Tiff files read/write support" ON)
option(BA_TESTS "Build tests" ON)
option(BA_DOCS "Build documentation" ON)
option(BA_APPLE_HOMEBREW "Build BornAgain with Homebrew under MacOS" OFF)
option(BA_PY_PACK "Build BornAgain Python wheel" ON)

# options that are off by default (switch on for additional functionality)
option(CONFIGURE_BINDINGS "Generate python bindings during build (requires swig)" OFF)
option(CONFIGURE_EXAMPLES "Configure examples (requires ruby)" OFF)
option(CONFIGURE_DOXY "Configure Doxygen source documentation" OFF)
option(ALLCONFIG "Regenerate Py wrappers, examples, Doxyfiles" OFF)
option(ZERO_TOLERANCE "Terminate compilation on warnings" OFF)
option(DEVELOPER_CHECKS "Checks required from developers but not from external users" OFF)
option(DEV "Development: turns ALLCONFIG, ZERO_TOLERANCE, DEVELOPER_CHECKS on" OFF)
option(BA_COVERAGE "Build with test coverage information" OFF)
option(BA_DEBUG_OPTIMIZATION "Build with debug optimization (gcc only)" OFF)
option(BA_TIDY "Invokes clang-tidy" OFF)
option(ALGORITHM_DIAGNOSTIC "Let some algorithms set diagnostic variables" OFF)
option(BA_APPLE_BUNDLE "Create a MacOS bundle" OFF)
option(BA_CPP_API "Install header files" OFF)
option(BA_3ARCH
    "Reduced tolerance for persistence tests on architectures not covered by maintainer CI" OFF)

# options with non-boolean value

set(SEARCH_PYTHON_PATH "" CACHE INTERNAL "Search path for Python platform to be used for packaging")
string(STRIP "${SEARCH_PYTHON_PATH}" SEARCH_PYTHON_PATH)

# options that set other options

if(DEV)
    set(ALLCONFIG ON)
    set(ZERO_TOLERANCE ON)
    set(DEVELOPER_CHECKS ON)
endif()
if(ALLCONFIG)
    set(CONFIGURE_BINDINGS ON)
    set(CONFIGURE_EXAMPLES ON)
    set(CONFIGURE_DOXY ON)
    # TODO what about targets 'figures', 'excopy'? see Tests/Examples/CMakeLists.txt
    # TODO what about target 'src_graphs'? see Doc/graph/CMakeLists.txt
endif()

# check compatibility of options

if(BA_APPLE_BUNDLE AND NOT APPLE)
    message(FATAL_ERROR "BA_APPLE_BUNDLE=ON although hardware is not APPLE")
endif()

if(BA_APPLE_BUNDLE AND BA_APPLE_HOMEBREW)
    message(FATAL_ERROR "BA_BUNDLE and BA_APPLE_HOMEBREW are mutually exclusive options.")
endif()

if(BA_TIDY)
    if (BORNAGAIN_PYTHON)
        message(FATAL_ERROR "BA_TIDY is incompatible with BORNAGAIN_PYTHON")
    endif()
    if(NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        message(FATAL_ERROR "BA_TIDY requires compiler Clang")
    endif()
endif()

if(BA_TESTS AND NOT BA_PY_PACK)
    message(FATAL_ERROR "Tests need the BA Python package, hence BA_PY_PACK must be ON.")
endif()

### set C++ standard

if(BA_CPP20)
    set(CMAKE_CXX_STANDARD 20)
else()
    set(CMAKE_CXX_STANDARD 17)
endif()

### Generator type (Release|Debug)

# Show info about generator type; set CMAKE_BUILD_TYPE if not given
if(CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Generator type: Multi-configuration generator")
else()
    message(STATUS "Generator type: Single-configuration generator")
endif()
message("    CMAKE_CONFIGURATION_TYPES: ${CMAKE_CONFIGURATION_TYPES}")
# The following is not correct/does not have any effect for multi-configuration generators.
# But when correcting this, be aware that CMAKE_BUILD_TYPE is used in more scripts!
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING "" FORCE)
    message("    CMAKE_BUILD_TYPE type not given - forced to 'Release'")
else()
    string(TOUPPER "${CMAKE_BUILD_TYPE}" _upper_build_type)
    set(BUILD_${_upper_build_type} 1)
endif()
message("    CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
configure_file("${PROJECT_SOURCE_DIR}/cmake/configurables/config_build.h.in"
    "${PROJECT_BINARY_DIR}/inc/config_build.h"
    @ONLY)


### Configure tests

if(BA_TESTS)
    # GoogleTest: `gtest_discover_tests` discovers tests by asking the _compiled test executable_
    # to enumerate its tests. `PRE_TEST` delays test discovery until just prior to test execution;
    # this avoids calling the executables during the build phase.
    set(CMAKE_GTEST_DISCOVER_TESTS_DISCOVERY_MODE PRE_TEST)

    include(CTest) # equivalent to "enable_testing() ???
    add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} -LE Fullcheck)
       # => 'make check' is an alias for 'ctest'
    add_custom_target(fullcheck COMMAND ${CMAKE_CTEST_COMMAND})
       # => 'make check' is an alias for 'ctest'
endif()


### Operating system and compilation flags

# no support for systems with addresses shorter than 64 bits
if(CMAKE_SIZEOF_VOID_P EQUAL 4)
    message(FATAL "Found a 32bit system - no longer supported")
elseif(CMAKE_SIZEOF_VOID_P LESS 8)
    message(FATAL "Found a ${CMAKE_SIZEOF_VOID_P} byte system - very unexpected and not supported")
endif()

# introduce `LINUX` flag (whereas `APPLE` and `WIN32` are set by CMake)
if(UNIX AND CMAKE_SYSTEM_NAME MATCHES Linux)
    set(LINUX ON)
endif()

# the host system must be Linux, Apple or Windows
if(NOT (LINUX OR APPLE OR WIN32))
    message(FATAL_ERROR "Operating system ${CMAKE_SYSTEM_NAME} is not supported")
endif()

if(LINUX)
    include(cmake/BornAgain/Linux)
elseif(APPLE)
    include(cmake/BornAgain/MacOS)
elseif(WIN32)
    include(cmake/BornAgain/Windows)
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(CLANG ON)
    string(APPEND CMAKE_CXX_FLAGS " -Wno-misleading-indentation")
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(GCC ON)
    string(APPEND CMAKE_CXX_FLAGS " -fdiagnostics-color=always")
elseif(NOT WIN32)
    message(FATAL_ERROR "Unsupported compiler, id=${CMAKE_CXX_COMPILER_ID}")
endif()

set(CMAKE_VISIBILITY_INLINES_HIDDEN YES)
if(ZERO_TOLERANCE)
    if (WIN32)
        string(APPEND CMAKE_CXX_FLAGS " /WX")
    else()
        string(APPEND CMAKE_CXX_FLAGS " -Werror")
    endif()
endif()
if(ALGORITHM_DIAGNOSTIC)
    string(APPEND CMAKE_CXX_FLAGS " -DALGORITHM_DIAGNOSTIC=ON")
endif()
string(APPEND CMAKE_CXX_FLAGS_DEBUG " -DBA_DEBUG") # changes behavior of ASSERT

include(cmake/BornAgain/CompilerInfo)

### Further configuration

# function definitions
include(cmake/commons/GetFilenameComponent) # fct get_filename_component (overwrites CMake's built-in)
if(BORNAGAIN_PYTHON)
    include(cmake/multipython/SwigLib) # fct SwigLib
endif()
include(cmake/BornAgain/MakeLib) # fct MakeLib

# main settings
include(cmake/BornAgain/Directories)
include(cmake/BornAgain/FindLibraries)

if(WIN32)
    include(cmake/BornAgain/InstallDll)
endif()

# Python
if(BORNAGAIN_PYTHON)
    include(cmake/multipython/PyDependences)
endif()

if(BA_GUI)
    include(cmake/BornAgain/Qt)
    string(APPEND CMAKE_CXX_FLAGS " -DHAVE_QT=ON")
endif()

include(cmake/BornAgain/ConfigureFiles)

### Configure source components

# library Fit
add_subdirectory(Fit/3rdparty)
add_subdirectory(Fit)

# other components
set(CoreComponents "Base")
if (BORNAGAIN_PYTHON)
    set(CoreComponents "${CoreComponents};PyCore")
endif()
set(CoreComponents "${CoreComponents};Param;Sample;Resample;Device;Sim")
set(AllComponents "${CoreComponents};Img3D;GUI")

# code analysis
if(LINUX AND DEVELOPER_CHECKS)
    include(cmake/BornAgain/SourceChecks)
endif()
if(BA_COVERAGE)
  include(cmake/BornAgain/Coverage)
endif()

# third-party code
add_subdirectory(3rdparty/common)
add_subdirectory(3rdparty/Core)
if(BA_GUI)
    add_subdirectory(3rdparty/GUI/qcustomplot)
endif()

# from here on our own code, occasionally scrutinized by clang-tidy
if(BA_TIDY)
    set(CMAKE_CXX_CLANG_TIDY "clang-tidy") # has effect only if compiler is clang; uses .clang-tidy
endif()

# configure core component libraries
foreach(lib ${CoreComponents})
    add_subdirectory(${lib})
endforeach()
if(BORNAGAIN_PYTHON)
    if (CONFIGURE_EXAMPLES)
        add_subdirectory(rawEx)
    endif()
endif()

# GUI
if(BA_GUI)
    add_subdirectory(Img3D)
    add_subdirectory(GUI)
    add_subdirectory(App)
endif()

# tests
if(BA_TESTS)
    if(BA_3ARCH)
        add_compile_definitions(BA_OTHER_ARCH=ON)
    endif()
    add_subdirectory(Tests/Unit)
    if(BORNAGAIN_PYTHON)
        add_subdirectory(Tests/Examples)
        add_subdirectory(Tests/Py)
    endif()
    add_subdirectory(Tests/SimFactory)
    add_subdirectory(Tests/Functional)
    add_subdirectory(Tests/Suite)
endif()


# documentation
if (BA_DOCS)
    add_subdirectory(Doc/man)

    if(BORNAGAIN_PYTHON AND BA_TESTS)
        # NOTE: target 'figures' is defined in Tests and is needed for the documentation
        add_subdirectory(hugo)
        add_subdirectory(Doc/graph)
    endif()

    if(CONFIGURE_DOXY)
        add_subdirectory(Doc/Doxygen)
    endif()
endif()

# to show CMake and other auxiliary scripts in Qt creator
file(GLOB_RECURSE ScriptFiles cmake/configurables/* deploy/*)
add_custom_target(scripts SOURCES ${ScriptFiles})

### Finalize

# make package targets
include(cmake/BornAgain/Pack)

# local installation (only for Linux)
if(LINUX)
    set(BA_INSTALL_SCRIPT "${CMAKE_BINARY_DIR}/cmake_install.cmake")
    # install only the BornAgain executable, BornAgain libraries and the examples
    add_custom_target(install_local
        COMMAND ${CMAKE_COMMAND} -D COMPONENT=Applications -P ${BA_INSTALL_SCRIPT}
        COMMAND ${CMAKE_COMMAND} -D COMPONENT=Libraries -P ${BA_INSTALL_SCRIPT}
        COMMAND ${CMAKE_COMMAND} -D COMPONENT=Manual -P ${BA_INSTALL_SCRIPT}
        COMMAND ${CMAKE_COMMAND} -D COMPONENT=Examples -P ${BA_INSTALL_SCRIPT}
        )
endif()

# build log
include(cmake/BornAgain/BuildLog)
install(FILES ${BA_BUILD_LOG} DESTINATION ${destination_share})
message(STATUS "BornAgain build log written to '${BA_BUILD_LOG}'")

message(STATUS "CMake done")

=== App/CMakeLists.txt ===
###############################################################################
# Builds BornAgain/GUI main executable
###############################################################################

if(WIN32)
    set(executable_name BornAgain)
else()
    set(executable_name bornagain)
endif()

set(source_files main.cpp AppOptions.cpp)

# -----------------------------------------------------------------------------
# Qt configuration
# -----------------------------------------------------------------------------
set(CMAKE_AUTOMOC ON)

# -----------------------------------------------------------------------------
# executable icons
# -----------------------------------------------------------------------------
if(WIN32)
    set(system_addons bornagain.rc)
    if(NOT win32_console)
        set(executable_options WIN32)
    endif()
endif()

if(APPLE)
    set(MACOSX_BUNDLE_ICON_FILE BornAgain.icns)
    set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/BornAgain.icns
        PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
    if(BA_APPLE_BUNDLE)
        set(executable_options MACOSX_BUNDLE)
    endif()
endif()

# -----------------------------------------------------------------------------
# executable
# -----------------------------------------------------------------------------
add_executable(${executable_name}
    ${executable_options}
    ${source_files}
    ${system_addons})

# -----------------------------------------------------------------------------
# dependencies
# -----------------------------------------------------------------------------
target_link_libraries(${executable_name} PRIVATE BornAgainGUI)
target_include_directories(${executable_name} PRIVATE ${CMAKE_SOURCE_DIR})

# -----------------------------------------------------------------------------
# extra target properties
# -----------------------------------------------------------------------------
if(BORNAGAIN_PYTHON)
    target_compile_definitions(${executable_name} PRIVATE -DBORNAGAIN_PYTHON)
endif()

if(WIN32)
    set_target_properties(${executable_name} PROPERTIES LINK_OPTIONS /ENTRY:mainCRTStartup)
    if(win32_console)
        set_target_properties(${executable_name} PROPERTIES COMPILE_DEFINITIONS _CONSOLE)
    endif()
endif()

# -----------------------------------------------------------------------------
# runtime library paths
# -----------------------------------------------------------------------------
#   See our deployment paper (Nejati et al 2024) for explanation.

if(LINUX)
    # NOTE: RPATH must be set also in `GUI/CMakeLists.txt`
    set(link_flags "-Wl,-rpath,\$ORIGIN/../lib")
    set_target_properties(${executable_name} PROPERTIES LINK_FLAGS ${link_flags})
elseif(APPLE)
    set(MACOSX_BUNDLE_IDENTIFIER org.bornagainproject.BornAgain)
    configure_file(${CONFIGURABLES_DIR}/MacOSXBundleInfo.plist.in ${BUILD_VAR_DIR}/Info.plist @ONLY)

    set_target_properties(${executable_name}
        PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${BUILD_VAR_DIR}/Info.plist)

    if(BA_APPLE_BUNDLE)
        set(link_flags "-Wl,-rpath,@loader_path/../lib,-rpath,@loader_path/../Frameworks")
    else()
        set(link_flags "-Wl,-rpath,@loader_path/../lib/")
    endif()

    set_target_properties(${executable_name} PROPERTIES LINK_FLAGS ${link_flags})
endif()

# -----------------------------------------------------------------------------
# installation section
# -----------------------------------------------------------------------------
if(BA_APPLE_BUNDLE)
    install(TARGETS ${executable_name} BUNDLE DESTINATION "." COMPONENT Applications)
else()
    install(TARGETS ${executable_name} RUNTIME DESTINATION ${destination_bin}
        COMPONENT Applications)
endif()

set(image_files
    ${CMAKE_CURRENT_SOURCE_DIR}/BornAgain.ico
    ${CMAKE_CURRENT_SOURCE_DIR}/BornAgain.icns
    ${CMAKE_SOURCE_DIR}/GUI/images/BornAgain_48x48.png
    ${CMAKE_SOURCE_DIR}/GUI/images/BornAgain_64x64.png)
install(FILES ${image_files} DESTINATION ${destination_images} COMPONENT Applications)

# -----------------------------------------------------------------------------
# system dependent installation
# -----------------------------------------------------------------------------
if(BA_APPLE_BUNDLE)
    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/BornAgain.icns
        DESTINATION ${destination_root}/Resources/)
    install(FILES ${CMAKE_SOURCE_DIR}/cmake/configurables/qt.conf.mac
        DESTINATION ${destination_root}/Resources/
        RENAME qt.conf)

    # adjust MacOS bundle
    get_property(exe_dir TARGET ${executable_name} PROPERTY RUNTIME_OUTPUT_DIRECTORY)
    set(MACPKG_MAIN_EXE "${exe_dir}/${executable_name}.app/Contents/MacOS/${executable_name}")

    # list of BornAgain core libraries
    set(MACPKG_CORE_LIBS "$CACHE{BornAgain_LIBRARIES}")

    # list of required Qt plugins (paths relative to Qt root dir)
    set(MACPKG_QT_PLUGINS_RELDIR "${QT6_INSTALL_PLUGINS}")
    set(MACPKG_QT_PLUGINS
        platforms/libqcocoa.dylib
        iconengines/libqsvgicon.dylib
        imageformats/libqjpeg.dylib
        imageformats/libqsvg.dylib
        styles/libqmacstyle.dylib
        )
    # Qt plugins directory in within the MacOS bundle
    set(MACPKG_QT_PLUGINS_DIR PlugIns)  # conform to settings in `qt.conf`
    # convert CMake list to space-separated lists
    set(MACPKG_EXTRA_LIBS "${BA_Dependencies}")

    configure_file("${CMAKE_SOURCE_DIR}/deploy/mac/mac_package.py.in"
        "${BUILD_VAR_DIR}/mac_package.py" @ONLY)

endif()

if(WIN32)
    message(STATUS "Configuring the GUI package")

    foreach(comp ${QtComponents})
        set(QtComp Qt6::${comp})
        get_target_property(dll ${QtComp} LOCATION_Release)
        get_property(dll TARGET ${QtComp} PROPERTY LOCATION_Release)
        install(FILES ${dll} DESTINATION ${destination_lib} COMPONENT WinLibraries)
        message(STATUS "Install Qt lib ${QtComp} (${dll})")
    endforeach()

    # extract Qt root-dir
    # 'C:/Qt/6.2.4/msvc2019_64/lib/cmake/Qt6' => 'C:/Qt/6.2.4/msvc2019_64'
    file(TO_CMAKE_PATH "${Qt_DIR}" qt_dir_str)

    install(FILES ${Qt_DIR}/bin/opengl32sw.dll
        DESTINATION ${destination_lib}
        COMPONENT WinLibraries)
    install(FILES ${Qt_PLUGINS_DIR}/platforms/qwindows.dll
        DESTINATION bin/platforms
        COMPONENT WinLibraries)
    install(FILES ${Qt_PLUGINS_DIR}/iconengines/qsvgicon.dll
        DESTINATION bin/iconengines
        COMPONENT WinLibraries)
    install(FILES ${Qt_PLUGINS_DIR}/imageformats/qjpeg.dll ${Qt_PLUGINS_DIR}/imageformats/qsvg.dll
        DESTINATION bin/imageformats
        COMPONENT WinLibraries)

    set(QT_VISTA_STYLE ${Qt_PLUGINS_DIR}/styles/qwindowsvistastyle.dll)
    if(EXISTS ${QT_VISTA_STYLE})
        install(FILES ${QT_VISTA_STYLE} DESTINATION bin/styles COMPONENT WinLibraries)
    else()
        message(AUTHOR_WARNING File ${QT_VISTA_STYLE} not found.)
    endif()
    unset(QT_VISTA_STYLE)
endif()

if(LINUX)
    set(LINUXPKG_MAIN_EXE "${CMAKE_BINARY_DIR}/bin/${executable_name}")
    set(LINUXPKG_FRAMEWORK_DEST "${destination_lib}")

    configure_file(${CMAKE_SOURCE_DIR}/deploy/linux/adjust_pkg_linux.sh.in
        ${BUILD_VAR_DIR}/adjust_pkg_linux.sh @ONLY)
endif()

# execute package-fixing script before CPack builds the final package file
configure_file(${CMAKE_SOURCE_DIR}/cmake/configurables/FixPack.cmake.in
    ${BUILD_VAR_DIR}/FixPack.cmake @ONLY)

install(SCRIPT ${BUILD_VAR_DIR}/FixPack.cmake)

=== Fit/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainFit
############################################################################

set(component Fit)
set(lib BornAgain${component})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- make the library ---

add_library(${lib} SHARED)
MakeLib(${lib} "${CMAKE_CURRENT_BINARY_DIR}/Wrap" "${source_files}" "${include_files}")

# --- external dependences ---

target_link_libraries(${lib}
    PRIVATE
    ${RootMinimizers_LIBRARY}
    )

target_include_directories(${lib}
    PUBLIC
    ${CMAKE_SOURCE_DIR}
    )

target_include_directories(${lib} SYSTEM
    PUBLIC
    ${LibHeinz_INCLUDE_DIR}
    ${Boost_INCLUDE_DIRS}  # because needed by Fit/Test/Unit ?
    PRIVATE
    ${RootMinimizers_INCLUDE_DIRS}
    )

=== Doc/graph/CMakeLists.txt ===
file(GLOB source_files *.gv)

set(outdir ${CMAKE_SOURCE_DIR}/hugo/static/img/auto/src_doc)
file(MAKE_DIRECTORY ${outdir})

set(outfiles "")
foreach(src ${source_files})
    get_filename_component(name ${src} NAME_WLE)
    set(outfile ${outdir}/${name}.svg)
    list(APPEND outfiles ${outfile})
    add_custom_command(
        OUTPUT ${outfile}
        DEPENDS ${src}
        COMMAND dot ${src} -Tsvg > ${outfile}
    )
endforeach()

add_custom_target(src_graphs DEPENDS ${outfiles})

add_dependencies(webdoc src_graphs)

=== Tests/Examples/CMakeLists.txt ===
# BornAgain/Tests/Examples/CMakeLists.txt
#
# For the Python scripts in directory BornAgain/Examples:
# - test against reference, with mini detectors
# - under target 'figures', generate high-resolution figures for hugo
# - under target 'excopy', copy example sources to hugo

set(OUTPUT_DIR ${TEST_OUTPUT_DIR}/MiniExamples)
file(MAKE_DIRECTORY ${OUTPUT_DIR})

set(FIG_DIR ${CMAKE_SOURCE_DIR}/hugo/static/img/auto)

add_custom_target(figures) # generate high-resolution figures and store them in FIG_DIR
add_custom_target(manualtest)

file(MAKE_DIRECTORY ${FIG_DIR})
foreach(subdir ff fq offspec scatter2d specular varia)
    file(MAKE_DIRECTORY ${OUTPUT_DIR}/${subdir})
    file(MAKE_DIRECTORY ${FIG_DIR}/${subdir})
endforeach()

add_custom_target(excopy
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${EXAMPLES_PUBL_DIR}
       ${CMAKE_SOURCE_DIR}/hugo/static/py/auto/Examples)

####################################################################################################
#  Test functions
####################################################################################################

macro(parse_example example)
    cmake_path(SET MINI_SCRIPT NORMALIZE ${EXAMPLES_TEST_DIR}/${example}.py)
    cmake_path(SET PUBL_SCRIPT NORMALIZE ${EXAMPLES_FIGURES_DIR}/${example}.py)
    get_filename_component(EXAMPLE_NAME ${MINI_SCRIPT} NAME_WE)
    get_filename_component(EXAMPLE_SUBDIR ${example} DIRECTORY)
endmacro()

set(launch_env COMMAND ${CMAKE_COMMAND} -E env)
set(launch_py
    BA_DATA_DIR=${EXAMPLES_DATA_DIR}
    PYTHONPATH=${BA_PY_SOURCE_OUTPUT_DIR}
    ${Python3_EXECUTABLE})

# Register example that plots but has no persistence test.
function(run_example example)
    parse_example(${example})
    string(REPLACE "/" "." TARGET_NAME Example.${example}.fig)
    add_test(NAME Example.run.${EXAMPLE_NAME}
        ${launch_env} ${launch_py} ${MINI_SCRIPT} show=n)
    add_custom_target(${TARGET_NAME}
        ${launch_env} ${launch_py} ${PUBL_SCRIPT}
           show=n figfile=${FIG_DIR}/${EXAMPLE_SUBDIR}/${EXAMPLE_NAME}.png)
    add_dependencies(figures ${TARGET_NAME})
endfunction()

# Register example that has no output but is tested for running through.
function(run_plotless example)
    parse_example(${example})
    string(REPLACE "/" "." TARGET_NAME Example.${example}.run)
    add_test(NAME ${TARGET_NAME}
        ${launch_env} ${launch_py} ${MINI_SCRIPT}
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
endfunction()

# Register example with target 'manualtest'.
function(run_manually example)
    parse_example(${example})
    string(REPLACE "/" "." TARGET_NAME Example.${example}.manualtest)
    add_custom_target(${TARGET_NAME}
        COMMAND echo "### MANUAL TEST: EXAMPLE ${EXAMPLE_NAME}"
        ${launch_env} ${launch_py} ${MINI_SCRIPT}
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
    add_dependencies(manualtest ${TARGET_NAME})
endfunction()

# Register example that plots and has persistence test.
function(test_equality example reference tolerance)
    parse_example(${example})
    string(REPLACE "/" "." TARGET_NAME Example.${example}.persist)
    cmake_path(SET outfile NORMALIZE ${OUTPUT_DIR}/${example})
    cmake_path(SET reffile NORMALIZE ${REFERENCE_DIR_MINIEXAMPLES}/${reference})
    add_test(NAME ${TARGET_NAME}
        ${launch_env} ${launch_py} ${MINI_SCRIPT} show=n datfile=${outfile}
            tolerance=${tolerance} reference=${reffile}
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
    add_custom_target(${TARGET_NAME}
        ${launch_env} ${launch_py} ${PUBL_SCRIPT}
          show=n figfile=${FIG_DIR}/${EXAMPLE_SUBDIR}/${EXAMPLE_NAME}.png)
    add_dependencies(figures ${TARGET_NAME})
endfunction()

# Python persistence test: run modified example, and compare with reference data.
function(test_example example tolerance)
    test_equality(${example} ${example} ${tolerance})
endfunction()

####################################################################################################
#  Test collection
####################################################################################################

# Relatively high tolerance is not a problem for the tests involving Monte Carlo integration
# because of its probabilistic nature.
# The more integration points, the less the dispersion of the results.
# But unlike other types of examples, MC integration over detector pixels is very
# unstable if bins are too large and intensity within a pixel varies
# by many orders of magnitudes.
# If the test fails too frequently and the discrepancy is too high, increase
# not just the number of integration points, but also the number of detector pixels
# and update the reference data.

run_plotless(bayesian/likelihood_sampling)

test_example(ff/BarLorentz 2e-10)
test_example(ff/Bipyramid4 2e-10)
test_example(ff/Box 2e-10)
test_example(ff/CantellatedCube 2e-10)
test_example(ff/Cone 2e-10)
test_example(ff/CosineRippleBox 2e-10)
test_example(ff/Cylinder 2e-10)
test_example(ff/Dodecahedron 2e-9) # reduced accuracy on i386
test_example(ff/EllipsoidalCylinder 2e-10)
test_example(ff/HemiEllipsoid 2e-10)
test_example(ff/HorizontalCylinder 2e-10)
test_example(ff/Icosahedron 2e-10)
test_example(ff/PlatonicOctahedron 2e-10)
test_example(ff/PlatonicTetrahedron 2e-10)
test_example(ff/Prism3 2e-10)
test_example(ff/Prism6 2e-10)
test_example(ff/Pyramid2 2e-10)
test_example(ff/Pyramid3 2e-10)
test_example(ff/Pyramid4 2e-10)
test_example(ff/Pyramid6 2e-10)
test_example(ff/SawtoothRippleBox 2e-10)
test_example(ff/Sphere 2e-10)
test_example(ff/Spheroid 2e-10)
test_example(ff/TruncatedCube 2e-10)
test_example(ff/SphericalSegment 2e-10)
test_example(ff/SpheroidalSegment 2e-10)

run_plotless(fit/algo/fit_rosenbrock)

run_plotless(fit/scatter2d/consecutive_fitting)
run_plotless(fit/scatter2d/custom_objective_function)
# run_plotless(fit/scatter2d/expfit_galaxi) issue #813
run_plotless(fit/scatter2d/find_background)
run_plotless(fit/scatter2d/fit2d)
run_plotless(fit/scatter2d/fit_along_slices)
run_plotless(fit/scatter2d/fit_gisas)
run_plotless(fit/scatter2d/fit_with_masks)
run_plotless(fit/scatter2d/lmfit_basics)
run_plotless(fit/scatter2d/lmfit_with_plotting)
run_plotless(fit/scatter2d/minimizer_settings)
run_plotless(fit/scatter2d/multiple_datasets)

if (Python3_VERSION_MINOR GREATER 8)
    run_plotless(fit/specular/Honeycomb_fit)
    run_plotless(fit/specular/Pt_layer_fit)
endif()
run_plotless(fit/specular/PolarizedSpinAsymmetryFit)
run_plotless(fit/specular/TREFF_Ni_film)
run_example(fit/specular/Specular1Par)

run_example(fq/Sphere)

test_example(offspec/Offspec1 2e-10)
test_example(offspec/OffspecLambda 2e-10) # issue #711
test_example(offspec/OffspecResolved 2e-10) # issue #711

test_example(scatter2d/ApproximationDA 2e-10)
test_example(scatter2d/ApproximationLMA 2e-10)
test_example(scatter2d/ApproximationSSCA 2e-10)
# run_example(scatter2d/AxesInDifferentUnits) issue #815
test_example(scatter2d/BeamDivergence 2e-10)
test_example(scatter2d/BiMaterialCylinders 2e-10)
test_example(scatter2d/BoxesWithSpecularPeak 2e-10)
test_example(scatter2d/ConstantBackground 2e-10)
test_example(scatter2d/CoreShellNanoparticles 2e-10)
test_example(scatter2d/CoreShellNanoparticles2 2e-10)
test_example(scatter2d/CorrelatedRoughness 2e-10)
test_example(scatter2d/CosineRipplesAtRectLattice 2e-10)
test_example(scatter2d/CustomFormfactor 2e-10)
test_example(scatter2d/Cylinders 2e-10)
test_example(scatter2d/CylindersAndPrisms 2e-10)
test_example(scatter2d/CylindersInAverageLayer 2e-10)
test_example(scatter2d/CylindersInBA 2e-10)
test_example(scatter2d/DodecahedraSAS 2e-10)
test_example(scatter2d/FindPeaks 0.08) # MC integration ==> high tolerance is ok
test_example(scatter2d/HalfSpheresInAverageTopLayer 2e-10)
test_example(scatter2d/HexagonalLatticesWithBasis 2e-10)
test_example(scatter2d/Interference1DLattice 0.1) # MC integration ==> high tolerance is ok
test_example(scatter2d/Interference1DRadialParacrystal 2e-10)
test_example(scatter2d/Interference2DCenteredSquareLattice 2e-10)
test_example(scatter2d/Interference2DParacrystal 2e-10)
test_example(scatter2d/Interference2DRotatedSquareLattice 2e-10)
test_example(scatter2d/Interference2DSquareFiniteLattice 2e-10)
test_example(scatter2d/LargeParticles 0.05) # MC integration ==> high tolerance is ok
test_example(scatter2d/LatticeOrientationDistribution 2e-10)
test_example(scatter2d/MagneticCylinders1 2e-10)
test_example(scatter2d/MagneticCylinders2 2e-10)
test_example(scatter2d/MagneticSpheres 2e-10)
test_example(scatter2d/Mesocrystal 2e-10)
test_example(scatter2d/Mesocrystal2 2e-10)
test_example(scatter2d/Mesocrystal3 2e-10)
test_example(scatter2d/Mesocrystal4 2e-10)
test_example(scatter2d/ParticleAcrossInterface 2e-10)
test_example(scatter2d/PolarizedSANS 2e-10)
test_example(scatter2d/PolydisperseCylinders 2e-10)
run_example(scatter2d/PositionVariance) # TODO: issue 1145
test_example(scatter2d/RectangularGrating 0.06) # MC integration ==> high tolerance is ok
test_example(scatter2d/Resolution 2e-10)
test_example(scatter2d/RotatedPyramids 2e-10)
# test_example(scatter2d/RoughAndSpecular 0.3) # TODO: issue 864
test_example(scatter2d/SlicedLayer 2e-10)
test_example(scatter2d/SpheresAtHexLattice 2e-10)
test_example(scatter2d/TriangularRipple 2e-10)

test_example(specular/AlternatingLayers1 2e-13)
test_equality(specular/AlternatingLayers2 specular/AlternatingLayers1 2e-13)
test_example(specular/BeamFullDivergence 2e-10)
test_example(specular/Distributions 2e-10)
test_example(specular/FootprintCorrection 2e-10)
test_example(specular/GaussianBeams 1e-3) # TODO: issue 1132
test_example(specular/MagneticLayer 2e-10)
test_example(specular/MagneticLayerImperfect 2e-10)
run_example(specular/PolarizedSpinAsymmetry)
test_example(specular/RoughnessModel 2e-10)
test_example(specular/SpecularSimulationWithRoughness 2e-10)
test_example(specular/TOFRWithResolution 2e-10)
test_example(specular/TimeOfFlightReflectometry 2e-10)
test_example(specular/VsGenx 2e-10)

test_example(varia/Depthprobe1 2e-10)
run_example(varia/MaterialProfile)
run_example(varia/MaterialProfileWithParticles)
test_example(varia/Resonator 2e-10)
test_example(varia/RoughSurface 2e-10)
test_example(varia/TransmittedModulus 2e-10)

=== Tests/Functional/CMakeLists.txt ===
############################################################################
 # BornAgain/Tests/Functional/CMakeLists.txt (called from top-level CMakeLists.txt)
############################################################################

include_directories(${CMAKE_SOURCE_DIR}/Tests/Functional/TestMachinery)

add_subdirectory(Consistence)
add_subdirectory(Mumufit)
add_subdirectory(Fitting)
if(BA_GUI)
    add_subdirectory(GUIProjectCompatibility)
endif()

=== Tests/Functional/Consistence/CMakeLists.txt ===
include(GoogleTest) # provides gtest_discover_tests

set(test FuTestConsistence)

file(GLOB source_files *.cpp)

add_executable(${test} ${source_files} ${CMAKE_SOURCE_DIR}/Tests/GTestWrapper/TestAll.cpp)
target_compile_definitions(${test} PRIVATE -DBORNAGAIN_PYTHON)

target_link_libraries(${test} BornAgainTestSimFactory gtest)

gtest_discover_tests(${test} DISCOVERY_TIMEOUT 300 TEST_PREFIX Functional.Consistence.)

=== debian/changelog ===
bornagain (22~git20250325170646.93042f5+ds3-3) unstable; urgency=medium

  * Fix architecture name in the other package too…

 -- Roland Mas <lolando@debian.org>  Fri, 04 Apr 2025 17:40:59 +0200

bornagain (22~git20250325170646.93042f5+ds3-2) unstable; urgency=medium

  * Fix architecture name.

 -- Roland Mas <lolando@debian.org>  Fri, 28 Mar 2025 15:15:11 +0100

bornagain (22~git20250325170646.93042f5+ds3-1) unstable; urgency=medium

  * New upstream release.
  * Exclude i386 from supported architectures (as discussed with
    upstream).

 -- Roland Mas <lolando@debian.org>  Thu, 27 Mar 2025 15:07:30 +0100

bornagain (22~git20250324153133.6402d67+ds3-1) unstable; urgency=medium

  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Mon, 24 Mar 2025 17:52:07 +0100

bornagain (22~git20250318105918.d8e404e+ds3-1) unstable; urgency=medium

  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Tue, 18 Mar 2025 12:42:18 +0100

bornagain (22~git20250312170929.a3efd11+ds3-1) unstable; urgency=medium

  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Fri, 14 Mar 2025 16:53:13 +0100

=== debian/control ===
Source: bornagain
Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
Uploaders:
 Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>,
 Mika Pflüger <debian@mikapflueger.de>,
 Picca Frédéric-Emmanuel <picca@debian.org>,
 Roland Mas <lolando@debian.org>,
Section: science
Priority: optional
Build-Depends:
 clang-format <!nocheck>,
 cmake,
 debhelper-compat (= 13),
 dh-sequence-python3,
 doxygen-latex <!nodoc>,
 graphviz <!nodoc>,
 libboost-all-dev,
 libbz2-dev,
 libcerf-dev (>= 2.3),
 libeigen3-dev,
 libfftw3-dev,
 libformfactor-dev,
 libgsl0-dev,
 libheinz-dev,
 libqt6opengl6-dev,
 libtiff-dev,
 libxkbcommon-dev,
 libyaml-cpp-dev,
 python3-corner <!nopython>,
 python3-dev <!nopython>,
 python3-emcee <!nopython>,
 python3-fabio <!nopython>,
 python3-lmfit <!nopython>,
 python3-matplotlib <!nopython>,
 python3-numpy <!nopython>,
 python3-pip <!nopython>,
 python3-scipy <!nopython>,
 python3-setuptools <!nopython>,
 python3-yaml <!nopython>,
 qt6-base-dev,
 qt6-svg-dev,
 swig <!nopython>,
Build-Depends-Indep:
 hugo <!nodoc>,
 texlive-fonts-extra <!nodoc>,
 texlive-xetex <!nodoc>,
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/bornagain
Vcs-Git: https://salsa.debian.org/science-team/bornagain.git
Homepage: https://bornagainproject.org/
Rules-Requires-Root: no

Package: bornagain
Architecture: amd64 arm64 armel armhf mips64el ppc64el riscv64 s390x loong64 ppc64 sparc64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 python3-bornagain,
Description: Simulate and fit X-ray and neutron GISAS -- binary
 BornAgain is a software package to simulate and fit small-angle scattering at
 grazing incidence. It supports analysis of both X-ray (GISAXS) and neutron
 (GISANS) data. Calculations are carried out in the framework of the distorted
 wave Born approximation (DWBA). BornAgain provides a graphical user interface
 for interactive use as well as a generic Python and C++ framework for modeling
 multilayer samples with smooth or rough interfaces and with various types of
 embedded nanoparticles.
 .
 BornAgain supports:
 .
 Layers:
  * Multilayers without any restrictions on the number of layers
  * Interface roughness correlation
  * Magnetic materials
 .
 Particles:
  * Choice between different shapes of particles (form factors)
  * Particles with inner structures
  * Assemblies of particles
  * Size distribution of the particles (polydispersity)
 .
 Positions of Particles:
  * Decoupled implementations between vertical and planar positions
  * Vertical distributions: particles at specific depth in layers or on top.
  * Planar distributions:
    - fully disordered systems
    - short-range order distribution (paracrystals)
    - two- and one-dimensional lattices
 .
 Input Beam:
  * Polarized or unpolarized neutrons
  * X-ray
  * Divergence of the input beam (wavelength, incident angles) following
    different distributions
  * Possible normalization of the input intensity
 .
 Detector:
  * Off specular scattering
  * Two-dimensional intensity matrix, function of the output angles
 .
 Use of BornAgain:
  * Simulation of GISAXS and GISANS from the generated sample
  * Fitting to reference data (experimental or numerical)
  * Interactions via Python scripts or Graphical User Interface
 .
 If you use BornAgain in your work, please cite
  C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke (2015), BornAgain
  — Software for simulating and fitting X-ray and neutron small-angle
  scattering at grazing incidence, version <version you used>,
  http://www.bornagainproject.org

Package: python3-bornagain
Architecture: amd64 arm64 armel armhf mips64el ppc64el riscv64 s390x loong64 ppc64 sparc64
Depends:
 python3-matplotlib,
 python3-numpy,
 python3-yaml,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Simulate and fit X-ray and neutron GISAS -- Python3
 BornAgain is a software package to simulate and fit small-angle scattering at
 grazing incidence. It supports analysis of both X-ray (GISAXS) and neutron
 (GISANS) data. Calculations are carried out in the framework of the distorted
 wave Born approximation (DWBA). BornAgain provides a graphical user interface
 for interactive use as well as a generic Python and C++ framework for modeling
 multilayer samples with smooth or rough interfaces and with various types of
 embedded nanoparticles.
 .
 BornAgain supports:
 .
 Layers:
  * Multilayers without any restrictions on the number of layers
  * Interface roughness correlation
  * Magnetic materials
 .
 Particles:
  * Choice between different shapes of particles (form factors)
  * Particles with inner structures
  * Assemblies of particles
  * Size distribution of the particles (polydispersity)
 .
 Positions of Particles:
  * Decoupled implementations between vertical and planar positions
  * Vertical distributions: particles at specific depth in layers or on top.
  * Planar distributions:
    - fully disordered systems
    - short-range order distribution (paracrystals)
    - two- and one-dimensional lattices
 .
 Input Beam:
  * Polarized or unpolarized neutrons
  * X-ray
  * Divergence of the input beam (wavelength, incident angles) following
    different distributions
  * Possible normalization of the input intensity
 .
 Detector:
  * Off specular scattering
  * Two-dimensional intensity matrix, function of the output angles
 .
 Use of BornAgain:
  * Simulation of GISAXS and GISANS from the generated sample
  * Fitting to reference data (experimental or numerical)
  * Interactions via Python scripts or Graphical User Interface
 .
 If you use BornAgain in your work, please cite
  C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke (2015), BornAgain
  — Software for simulating and fitting X-ray and neutron small-angle
  scattering at grazing incidence, version <version you used>,
  http://www.bornagainproject.org
 .
  This package contains the Python bindings for use in scripts.

Package: bornagain-doc
Architecture: all
Section: doc
Depends:
 fonts-font-awesome,
 fonts-open-sans,
 fonts-roboto,
 libjs-bootstrap,
 libjs-jquery,
 libjs-popper.js,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 bornagain,
Multi-Arch: foreign
Description: Simulate and fit X-ray and neutron GISAS -- doc
 BornAgain is a software package to simulate and fit small-angle scattering at
 grazing incidence. It supports analysis of both X-ray (GISAXS) and neutron
 (GISANS) data. Calculations are carried out in the framework of the distorted
 wave Born approximation (DWBA). BornAgain provides a graphical user interface
 for interactive use as well as a generic Python and C++ framework for modeling
 multilayer samples with smooth or rough interfaces and with various types of
 embedded nanoparticles.
 .
 BornAgain supports:
 .
 Layers:
  * Multilayers without any restrictions on the number of layers
  * Interface roughness correlation
  * Magnetic materials
 .
 Particles:
  * Choice between different shapes of particles (form factors)
  * Particles with inner structures
  * Assemblies of particles
  * Size distribution of the particles (polydispersity)
 .
 Positions of Particles:
  * Decoupled implementations between vertical and planar positions
  * Vertical distributions: particles at specific depth in layers or on top.
  * Planar distributions:
    - fully disordered systems
    - short-range order distribution (paracrystals)
    - two- and one-dimensional lattices
 .
 Input Beam:
  * Polarized or unpolarized neutrons
  * X-ray
  * Divergence of the input beam (wavelength, incident angles) following
    different distributions
  * Possible normalization of the input intensity
 .
 Detector:
  * Off specular scattering
  * Two-dimensional intensity matrix, function of the output angles
 .
 Use of BornAgain:
  * Simulation of GISAXS and GISANS from the generated sample
  * Fitting to reference data (experimental or numerical)
  * Interactions via Python scripts or Graphical User Interface
 .
 If you use BornAgain in your work, please cite
  C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke (2015), BornAgain
  — Software for simulating and fitting X-ray and neutron small-angle
  scattering at grazing incidence, version <version you used>,
  http://www.bornagainproject.org
 .
  This package contains the BornAgain documentation.

=== debian/rules ===
#!/usr/bin/make -f
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

# deal with profiles
CONFIG_SWITCHES=-DCMAKE_DEB_HOST_MULTIARCH=$(DEB_HOST_MULTIARCH)

ifneq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCHES += -DCONFIGURE_DOXY=OFF
else
	CONFIG_SWITCHES += -DCONFIGURE_DOXY=ON
endif

ifneq ($(filter nopython,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCHES += -DBORNAGAIN_PYTHON=OFF -DCONFIGURE_BINDINGS=OFF
else
	CONFIG_SWITCHES += -DBORNAGAIN_PYTHON=ON -DCONFIGURE_BINDINGS=ON
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

export CMAKE_OPTIONS := \
  -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
  -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
  -DCMAKE_PREFIX_PATH="/usr/share/cmake/heinz;/usr/share/cmake/formfactor" \
  -DCMAKE_LIBRARY_PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/bornagain \
  -DCMAKE_BUILD_TYPE=Release \
  -DBA_3ARCH=ON

%:
	dh $@

execute_after_dh_clean:
	rm -rf hugo/public hugo/.hugo_build.lock
	find auto -name *.pyc -delete

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTIONS) $(CONFIG_SWITCHES) -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

override_dh_auto_test:
	cd obj-$(DEB_HOST_GNU_TYPE) && make -j1 test ARGS\+=--verbose ARGS\+=-j1

override_dh_auto_build-arch:
	dh_auto_build

override_dh_auto_build-indep:
	dh_auto_build
	cd hugo && hugo

execute_after_dh_auto_install:
	find debian/tmp -name __pycache__ | xargs -r rm -r
	rm -f debian/tmp/usr/share/Bornagain/bornagain_build.log

override_dh_install-arch:
	#  bornagain
	dh_install -p bornagain usr/bin/bornagain
	dh_install -p bornagain usr/lib/*/bornagain/_libBornAgainGUI.so
	dh_install -p bornagain usr/share/BornAgain/Images/* usr/share/bornagain/images/
	dh_install -p bornagain usr/share/man/

	# python3-bornagain
	dh_install -p python3-bornagain -X_libBornAgainGUI.so usr/lib/*/bornagain/*.so
	mkdir -p debian/tmp/usr/lib/python3/dist-packages/bornagain/lib
	cp obj-$(DEB_HOST_GNU_TYPE)/py/src/bornagain/lib/lib*.py debian/tmp/usr/lib/python3/dist-packages/bornagain/lib
	cp obj-$(DEB_HOST_GNU_TYPE)/py/src/bornagain/lib/__init__.py debian/tmp/usr/lib/python3/dist-packages/bornagain/lib
	cp obj-$(DEB_HOST_GNU_TYPE)/py/src/bornagain/*.py debian/tmp/usr/lib/python3/dist-packages/bornagain/
	dh_install -p python3-bornagain usr/lib/python3/*

override_dh_install-indep:
	# bornagain-doc
	dh_install -p bornagain-doc usr/share/BornAgain/Examples/* usr/share/doc/bornagain/examples/
	dh_install -p bornagain-doc hugo/public/* usr/share/doc/bornagain/html

execute_before_dh_missing-arch:
	# rm remaining files (workaround FTBFS...)
	rm -rf debian/tmp/usr/share

execute_before_dh_missing-indep:
	# rm remaining files (workaround FTBFS...)
	rm  -f debian/tmp/usr/bin/bornagain
	rm -rf debian/tmp/usr/lib
	rm -rf debian/tmp/usr/share/BornAgain/
	rm -f  debian/tmp/usr/share/man/man1/bornagain.1*
